package UroIrmPackage;

import ij.*;
import java.awt.*;
import java.awt.event.*;

/**
	create a plot that interact with the frame that calls him.  
	it gives an representation of array of float.
	it is a 2Dimension representation, 
	For each point, the plot save 3 datas :
		X-coordinate,Y-coordinate,position of the points in the main array.
*/
public class UroIrmPlot extends Panel implements MouseListener, MouseMotionListener,UroIrmMessage{
// general Declaration
	Graphics gCourant;	
	Dimension dim;
	String name_class = "URO-IRM : plot";	
	
	private float xplot[] ;
	private float  yplot[] ;
	private float indicePoint[];
	private String[] label_axes = new String[2];
	float[] selectedPoint;
// link with the calling class
	public Label comment;
	public boolean bzoom ;
// for the zoom
	private float[] zoom;
	private float[] coordArea;
	private static int decimalPrecision =0;

// for the axes 
	public static int WIDTH_MAX , HEIGHT_MAX , DIMSQUARE_AREA_SEARCH , DIM_POINT ;		
	public  static String LABEL_ABSCISSE ,LABEL_ORDONNEE ;

// dimension of the plot area
	public  static int HEIGHT_STRING , WIDTH_STRING ;
	public  static int OFFSET_BOTTOM, OFFSET_TOP , OFFSET_RIGHT,
			OFFSET_LEFT ,PLOT_WIDTH ,PLOT_HEIGHT ;
	public static int[] insidePlot = new int[4]; 

// for the graduation 	
	public  static int NUMBER_SCALEX = 10;
	public  static int  NUMBER_SCALEY = 10;
	public  static float graduationX ,subgraduationX, graduationY, subgraduationY ;
	public  static int gradDim = 2;
		// in oder to show a certain number of decimal .
		// the number must be in 10^(number of decimal)

	// default value 
	private float[] minMax = {0,10,0,10};
	float lengthscaleX = minMax[1] - minMax[0];
	float lengthscaleY = minMax[3] - minMax[2];
	Color PLOT_COLOR = Color.black;


// CONSTRUCTOR
	public UroIrmPlot(ImagePlus source) {
		addMouseListener(this);
		addMouseMotionListener(this);
		this.setSize(420, 200);
	}
	
	public UroIrmPlot(ImagePlus source,String abs, float[] X , String ord, float[] Y, float[] Indice) {
		addMouseListener(this);
		addMouseMotionListener(this);
		this.resize(420,200);
		xplot = X;
		yplot = Y;
		indicePoint = Indice;
		setLabelAxes(abs,ord);
		this.setBackground(Color.white);
	}

	public void paint(Graphics g) {
		super.paint(g);
		gCourant = g;
		clear();
		initDim();
		g.setColor(Color.black);
		paintBody(g);
		paintScale(g,minMax);
		plot(xplot,yplot,PLOT_COLOR); 
		g.setColor(Color.blue);
		g.drawRect(insidePlot[0],insidePlot[1],PLOT_WIDTH,PLOT_HEIGHT);
		displayArea(coordArea, Color.black);
     	}

	public void upDate() {
		super.update(gCourant);
	}

/** to set the Scale to a plot */
	public void setScale ( float[] data ) {
		clearScale();
		paintScale(gCourant,data);
	}

/** clear the scale */
	public void clearScale () {
		gCourant.clearRect(0,HEIGHT_STRING+2, insidePlot[0] - gradDim,HEIGHT_MAX);
		gCourant.clearRect(0,insidePlot[3]+gradDim+2,WIDTH_MAX-OFFSET_RIGHT-2,HEIGHT_MAX);
	}

/** clear very thing on the plot even the scale */
	public void clear() {
		gCourant.clearRect(0,0,WIDTH_MAX,HEIGHT_MAX);
	}

/** return the value of the current plot */
	public float[][] getPlot(){
		float[][] res = new float[3][];
		res[0] = xplot;
		res[1] = yplot;
		res[2] = indicePoint;
		return res;
	}

/** gives the label of the axes : X-axes,Y-axes */
	public String[] getLabelAxes(){
		return label_axes;
	}

/** set the label of the axes : abs = X-axes , ord = Y-axes*/
	public void setLabelAxes(String abs, String ord){
		label_axes[0] = abs;
		label_axes[1] = ord;
		if (gCourant !=null)
			paintBody(gCourant);
		repaint();
	}
	
/** give the value of the current zoom */
	public float[] getZoom(){
		return zoom;
	}

/** give the coordinate of the point selected by the mouse */
	public float[] getSelectedPoint(){
		return selectedPoint;
	}

/** reset the point selected by the mouse */
	public void resetSelectedPoint(){
		selectedPoint = null;
	}

/** give the length of the X-axes */
	public float getLengthScaleX(){
		return lengthscaleX;
	}

/** give the length of the Y-axes */
	public float getLengthScaleY(){
		return lengthscaleY;
	}
	
/** set the zoom */
	public void setZoom(float[] data) {
		zoom = data;
	}
	
/** give the coordinates of the plot area */
	public float[] getCoordArea(){
		return coordArea;
	}

/** set the coordinates of the plot area*/
	public void setCoordArea(float[] data) {
		coordArea = data;
	}

/** give the X-coordinates of the plot*/
	public float[] getPlotX(){
		return xplot;
	}
	
/** give the Y-coordinates of the plot*/
	public float[] getPlotY(){
		return yplot;
	}
	
/** give the 3rd argument of the plot*/
	public float[] getPlotIndicePoint(){
		return indicePoint ; 
	
	}	
	
/** change the current plot data */
	public void setPlot(float[][] data){
		if (data == null ||data.length < 3 )
			return ;
		xplot = new float[data[0].length]; xplot =data[0];
		yplot = new float[data[1].length]; yplot =data[1];
		indicePoint = new float[data[2].length]; indicePoint =data[2];
	}
	
/** change the X-coordinates of the plot */
	public void setPlotX(float[] data){
		if ( data !=null) {
			xplot = new float[data.length];
			xplot = data;
		}
	}

/** change the Y-coordinates of the plot */
	public void setPlotY(float[] data){
		if ( data !=null) {
			yplot = new float[data.length];
			yplot = data;
		}
	}

/** change the 3rd argument of the plot */
	public void setIndicePoint(float[] data){
		if ( data !=null) {
			indicePoint = new float[data.length];
			indicePoint = data;
		}
	}
	
/** give the minimum and the maximum of the plot*/
	public float[] getMinMax(){
		return minMax;
	}
	
/** set the minimum and the maximum of the X-axes*/
	public void setXMinMax(float minX , float maxX){
		setMinMax(minX,maxX,minMax[2],minMax[3]);
	}

/** give the minimum and the maximum of the Y-axes*/
	public void setYMinMax(float minY , float maxY){
		setMinMax(minMax[0],minMax[1],minY,maxY);
	}
	
/** give the minimum and the maximum of the plot*/
	public void setMinMax(float minx, float maxx, float miny, float maxy){
		float[] data = {minx,maxx,miny,maxy};
		setMinMax(data);
	}

/** give the minimum and the maximum of the plot*/
	public void setMinMax ( float[] data ) {
		if ( data == null || (data.length !=  4 ) ) 
			return ;
		if ( data[0] >= data[1] || data[2] >= data[3] ) {
				IJ.error(msg_err_minmax);
				minMax[0] = 0;minMax[1] = 10;
				minMax[2] = 0;minMax[3] = 10;
		} else  {
				minMax = data;
		}
		lengthscaleX = minMax[1] - minMax[0];
		lengthscaleY = minMax[3] - minMax[2];
		if (lengthscaleX < NUMBER_SCALEX || lengthscaleY < NUMBER_SCALEY )
			decimalPrecision = 10;
		else 
			decimalPrecision = 0;

	}

/** give the smallest and the highest points of the plot */
	public float[][] getMinMaxElement(){
		float[][] res = new float[2][3];
		res[0] = getFirstPoint();
		res[1] = getLastPoint();
		return res;
	}

	float[] getFirstPoint(){
		int start =0;
		int length = ((xplot.length > yplot.length )? yplot.length : xplot.length);
		while ( (start < length) &&  !(isInPlotArea(xplot[start],yplot[start])))
			start ++;
		if ( start > length )
			return null;
		float[] res = {xplot[start],yplot[start],indicePoint[start]};
		return (res);
	}

	float[] getLastPoint(){
		int length = ((xplot.length > yplot.length )? yplot.length : xplot.length);
		int start = length -1 ;
		while ( (start > 0) &&  !(isInPlotArea(xplot[start],yplot[start])) )
			start --;
		if ( start <0 )
			return null;
		float[] res = {xplot[start],yplot[start],indicePoint[start]};
		return (res);
	}

	private int f2i(float x ) {
		return((new Float(x)).intValue());
	}

	private String f2s ( float x ) {
		String result ="";
		int entier = f2i(x);
		int decimal = 0;
		if (x > 0 )
			decimal = f2i((x-entier)*decimalPrecision);
		else 
			decimal = f2i((entier-x)*decimalPrecision);

		if ( x<0 && entier==0)
			result+="-"; 
		result+=String.valueOf(entier); 
		if ( decimalPrecision == 0 )
			return result;
		return ( result + "." + String.valueOf(decimal));

	}

/** draw the axes */
	public void paintBody ( Graphics g ) {
		float x1,y1,x2,y2,subx,suby;	
	// draw the line for the graduation
		g.drawLine(insidePlot[0],insidePlot[1],insidePlot[0],insidePlot[3]);  // y_scale
		g.drawLine(insidePlot[0],insidePlot[3],insidePlot[2],insidePlot[3]); // x_scale
	// draw the graduation
		// on y_scale : 
		x1 = insidePlot[0] - gradDim; x2 = insidePlot[0]+gradDim;y1 = insidePlot[3]+graduationY; 
		subx=insidePlot[0];suby= insidePlot[3] -graduationY/2;
		for (  int i = insidePlot[1] ; i < (insidePlot[3]-graduationY) ; i+=graduationY){
			y1 -= graduationY;
			suby -= graduationY;
			g.drawLine(f2i(x1),f2i(y1),f2i(x2),f2i(y1));
			g.drawLine(f2i(x1),f2i(suby),f2i(subx),f2i(suby));
		}
		y1 -= graduationY;
		suby -= graduationY;
		if (y1 > insidePlot[1]) g.drawLine(f2i(x1),f2i(y1),f2i(x2),f2i(y1)); 
		if ( suby  > insidePlot[1] ) g.drawLine(f2i(x1),f2i(suby),f2i(subx),f2i(suby));

		// on x_scale	
		y1 = insidePlot[3] - gradDim; y2 = insidePlot[3]+gradDim;
		subx = insidePlot[0] - graduationX/2; suby =  insidePlot[3];
		for (  x1= insidePlot[0] ; x1 < (insidePlot[2]-graduationX) ; x1+=graduationX){
			subx += graduationX;
			g.drawLine(f2i(x1),f2i(y1),f2i(x1),f2i(y2));
			g.drawLine(f2i(subx),f2i(suby),f2i(subx),f2i(y2));
		} 
		subx += graduationX;
		if ( x1< insidePlot[2] ) g.drawLine(f2i(x1),f2i(y1),f2i(x1),f2i(y2));
		if ( subx < insidePlot[2] ) g.drawLine(f2i(subx),f2i(suby),f2i(subx),f2i(y2));
	}

/** PrecisionX et precisionY sont des multiples de 10 
	si ils sont > 0 alors il faut diviser par cette precision
	sinon il faut multiplier
*/
	void paintLabel(Graphics g ,int precisionX,int precisionY){
		String txt="",prec ="",symbole="";
		int precision;
	// for the abscisse
		if ( precisionX <0 ) {
			precision = -precisionX;symbole="*";
		} else { 
			precision = precisionX;	symbole="/";
		}
		prec = String.valueOf(precision);
		if ( prec.length() > 3) 
			prec = "10^"+ (prec.length()-1) ;
		if ( precision !=1){
			txt += "( "+ symbole + prec+" )";
			g.drawString(label_axes[0], f2i(insidePlot[2] + graduationX/2),insidePlot[3]-HEIGHT_STRING);
			g.drawString(txt,f2i(insidePlot[2] + graduationX/2),insidePlot[3]+HEIGHT_STRING);
		} else { 
			g.drawString(label_axes[0], f2i(insidePlot[2] + graduationX/2),insidePlot[3]+HEIGHT_STRING*1/2 );
		}
	//for the ordonnee
		if ( precisionY <0 ) {
			precision = -precisionY;symbole="*";
		} else { 
			precision = precisionY;	symbole="/";
		}
		prec = String.valueOf(precision);
		if ( prec.length() > 3) 
			prec = "10^"+ (prec.length()-1) ;
		if ( precisionY !=1){
			txt = "( "+ symbole + prec+" )";
			g.drawString(label_axes[1], 2,HEIGHT_STRING );
			int x = 2+ label_axes[1].length()*WIDTH_STRING ;
			g.drawString(txt,x,HEIGHT_STRING);
		} else { 
			g.drawString(label_axes[1], 2,HEIGHT_STRING );
		}
	}

/** put the value of each graduation */
	void paintScale( Graphics g , float[] data ) {
		float x1,y1,x2,y2,x,y;
		if (data == null ||data.length != 4 )
			return ;	

		float minX = data[0] , maxX = data[1],minY=data[2],maxY=data[3];
		float indice_graduationX = lengthscaleX  /  (NUMBER_SCALEX);
		float indice_graduationY = lengthscaleY /  (NUMBER_SCALEY);
		int VX = getPrecision(10*indice_graduationX),VY = getPrecision(10*indice_graduationY);
		if ( VX > 0 ) {indice_graduationX *= VX;minX *= VX ; maxX *=VX;
		} else if ( VX !=0 ){
			if ( VX < -100) {indice_graduationX /= -VX ;minX /= -VX ; maxX /= -VX;}
			else VX =1;
		}

		if ( VY > 0 ) {indice_graduationY *= VY;minY *= VY ; maxY *=VY;
		} else if ( VY !=0 ){
			if ( VY < -100 ) {indice_graduationY /= -VY ;minY /= -VY ; maxY /= -VY;}
			else VY = 1;
		}
		int stringOffSet = 0;
				
	// draw the scale
		// on y_scale : 
		stringOffSet = (f2s(minY).length()) * (WIDTH_STRING+2);
		x1 = insidePlot[0] - gradDim - WIDTH_STRING ;
 		y1 = insidePlot[3]+graduationY+HEIGHT_STRING/2-1;
		 
		y= minY- indice_graduationY ;
		for (  int i = insidePlot[1] ; i < (insidePlot[3]-graduationY) ; i+=graduationY){
			y1 -= graduationY;
			y += indice_graduationY;
			stringOffSet= (f2s(y).length())* WIDTH_STRING;
			g.drawString(f2s(y),f2i(x1)- stringOffSet ,f2i(y1));
		}
		y1 -= graduationY;
		y += indice_graduationY;
		if (y1 > insidePlot[1]) {
			stringOffSet= (f2s(y).length())* WIDTH_STRING;
			 g.drawString(f2s(y),f2i(x1)- stringOffSet ,f2i(y1));
		}
		
		// on x_scale	
		y1 = insidePlot[3] + gradDim + HEIGHT_STRING; 
		x = minX - indice_graduationX;
		for (  x1= insidePlot[0]; x1 < (insidePlot[2]) ; x1+=graduationX){
			x += indice_graduationX;
			stringOffSet = f2s(x).length()*WIDTH_STRING/2;
			g.drawString(f2s(x),f2i(x1)- stringOffSet,f2i(y1));
		} 
		paintLabel(g,VX,VY);
	}

	private int getPrecision(float value){
		if ( value == 0 )
			return 1;
		float num = value;
		int precision = 1;
		if ( f2i(num) == 0 ){
			precision*=10;num*=10;
			while ( f2i(num) == 0 ){ precision*=10; num*=10; } 
		} else {
			precision *= -10 ; num/=10;
			while ( f2i(num) != 0 ){ precision*=10; num/=10; }
			precision = (precision== -10)? 1 : precision/10; 
		}
		if ( precision != 1 )
			decimalPrecision = 10;
		return precision;
	}

/** draw a plot */
	public boolean plot(float[] x , float[] y, Color color) {
		if ( x == null || y == null  ) 
			return false;
		
		int length = ((x.length > y.length )? y.length : x.length);
		// adaptation to the scale		
		float oldpointX,oldpointY;		

		gCourant.setColor(color);

		oldpointX=x[0];oldpointY=y[0];
		for (int i = 0 ; i< length ; i++ ){
			if ( isInPlotArea(x[i],y[i]) ) { 
				if ( isInPlotArea(oldpointX,oldpointY) ) {
					addPoint(oldpointX,oldpointY,x[i],y[i]);
				}else {
					addPoint1(oldpointX,oldpointY,x[i],y[i]);
				}
			} else {
				if( isInPlotArea(oldpointX,oldpointY) ) {
					addPoint1(x[i],y[i],oldpointX,oldpointY);
				}else {
					addPoint2(oldpointX,oldpointY,x[i],y[i]);
				}
			}
			oldpointX=x[i];oldpointY=y[i];
		}
		return true;		
	}
	
// test selon les coordonnees de l'echelle
	protected boolean isInPlotArea (float X , float Y) {
		int x=(new Float(X)).intValue();
		int y =(new Float(Y)).intValue();
		return ( ( x >= minMax[0] ) && (x <= minMax[1]) 
				&& (y>=minMax[2]) && (y<=minMax[3])  ); 
	}
	
// test absolue ( ne depend pas de l'echelle )
	protected boolean isInPlotArea2 (float X , float Y) {
		int x=(new Float(X)).intValue();
		int y =(new Float(Y)).intValue();
		return ( ( x >= insidePlot[0] ) && (x <= insidePlot[2]) 
				&& (y>=insidePlot[1]) && (y<=insidePlot[3])  ); 
	}

	protected void addPoint(float oldX ,float oldY , float X , float Y ) {
		float[] coord,oldCoord;
		coord= (coord2pointValue(X,Y));
		oldCoord= (coord2pointValue(oldX,oldY));
		int x =(new Float(coord[0])).intValue();
		int y =(new Float(coord[1])).intValue();
		int oldx =(new Float(oldCoord[0])).intValue();
		int oldy =(new Float(oldCoord[1])).intValue();
		gCourant.drawRect(x-(DIM_POINT-1)/2,y-DIM_POINT/2,DIM_POINT,DIM_POINT);
		gCourant.drawRect(oldx-(DIM_POINT-1)/2,oldy-DIM_POINT/2,DIM_POINT,DIM_POINT);
		gCourant.drawLine(oldx,oldy,x,y);
	}

// the first point (X1,Y1) is outside of the plot area
	protected void addPoint1(float X1 ,float Y1 , float X2 , float Y2){
			float outX , outY, inX,inY;
			outX= (coord2pointValue(X1,Y1))[0];
			outY= (coord2pointValue(X1,Y1))[1];
			inX= (coord2pointValue(X2,Y2))[0];
			inY= (coord2pointValue(X2,Y2))[1];

			float[][] inter;
			float minx = ( outX < inX)? outX:inX;
			float maxx = ( outX > inX)? outX:inX;
			float miny = ( outY < inY)? outY:inY;
			float maxy = ( outY > inY)? outY:inY;

			if ( outX == inX){
				if ( outY > inY ) 
					gCourant.drawLine(f2i(inX),f2i(insidePlot[1]),f2i(inX),f2i(inY));
				else if ( outY < inY )
					gCourant.drawLine(f2i(inX),f2i(insidePlot[3]),f2i(inX),f2i(inY));
				return;
			} 
			if ( outY == inY){
				if ( outX > inX) 
					gCourant.drawLine(f2i(insidePlot[2]),f2i(inY),f2i(inX),f2i(inY));
				else if ( outX < inX )
					gCourant.drawLine(f2i(insidePlot[0]),f2i(inY),f2i(inX),f2i(inY));
				return;
			} 
	
			float mx = ( inY-outY)/(outX-inX);
			float my = ( outX -inX)/(inY-outY);
					
			inter = new float[4][2];
			inter[0][0] = my*(outY-insidePlot[1]) + outX;inter[0][1] = insidePlot[1]; 
			inter[1][0] = my*(outY-insidePlot[3]) + outX;inter[1][1] = insidePlot[3];
			inter[2][1] = mx*(outX-insidePlot[0]) + outY;inter[2][0] = insidePlot[0];
			inter[3][1] = mx*(outX-insidePlot[2]) + outY;inter[3][0] = insidePlot[2];
			
			if ( minx < inter[0][0] && inter[0][0] < maxx && isInPlotArea2 (inter[0][0],inter[0][1])	){
				gCourant.drawLine(f2i(inter[0][0]),f2i(inter[0][1]),f2i(inX),f2i(inY));
			}
			if ( minx < inter[1][0] && inter[1][0] < maxx  && isInPlotArea2 (inter[1][0],inter[1][1])	){
				gCourant.drawLine(f2i(inter[1][0]),f2i(inter[1][1]),f2i(inX),f2i(inY));
			}
			if ( miny < inter[2][1] && inter[2][1] < maxy && isInPlotArea2 (inter[2][0],inter[2][1])	){
				gCourant.drawLine(f2i(inter[2][0]),f2i(inter[2][1]),f2i(inX),f2i(inY));
			}
			if ( miny < inter[3][1] && inter[3][1] < maxy && isInPlotArea2 (inter[3][0],inter[3][1])	){
				gCourant.drawLine(f2i(inter[3][0]),f2i(inter[3][1]),f2i(inX),f2i(inY));
			}
	} 

// the two points are outside of the plot area
	protected void addPoint2(float X1 ,float Y1 , float X2 , float Y2){
			float outX , outY, inX,inY;
			outX= (coord2pointValue(X1,Y1))[0];
			outY= (coord2pointValue(X1,Y1))[1];
			inX= (coord2pointValue(X2,Y2))[0];
			inY= (coord2pointValue(X2,Y2))[1];

			float[][] inter;
			float[][] res;
			float minx = ( outX < inX)? outX:inX;
			float maxx = ( outX > inX)? outX:inX;
			float miny = ( outY < inY)? outY:inY;
			float maxy = ( outY > inY)? outY:inY;

			if ( outX == inX){
				if ( outX > insidePlot[0] && outX < insidePlot[2] &&
					miny > insidePlot[1] && maxy > insidePlot[3]  )	
					gCourant.drawLine(f2i(inX),f2i(insidePlot[1]),f2i(inX),f2i(insidePlot[3]));
				return;
			} 
			if ( outY == inY){
				if ( outY > insidePlot[1] && outY < insidePlot[3]&& 
				minx > insidePlot[0] && maxx< insidePlot[2]	 )	
					gCourant.drawLine(f2i(insidePlot[0]),f2i(inY),f2i(insidePlot[2]),f2i(inY));
				return;
			} 
	
			float mx = ( inY-outY)/(outX-inX);
			float my = ( outX -inX)/(inY-outY);
				
			inter = new float[4][2];
			inter[0][0] = my*(outY-insidePlot[1]) + outX;inter[0][1] = insidePlot[1]; 
			inter[1][0] = my*(outY-insidePlot[3]) + outX;inter[1][1] = insidePlot[3];
			inter[2][1] = mx*(outX-insidePlot[0]) + outY;inter[2][0] = insidePlot[0];
			inter[3][1] = mx*(outX-insidePlot[2]) + outY;inter[3][0] = insidePlot[2];
			
			res = new float[4][2];
			int counter = 0;
			if ( insidePlot[0] < inter[0][0] && inter[0][0] < insidePlot[2] &&
				miny < insidePlot[1] && maxy > insidePlot[1] ) {
				res[counter] = inter[0];counter++;
			}
			if ( insidePlot[0] < inter[1][0] && inter[1][0] < insidePlot[2] &&
				miny < insidePlot[3] && maxy > insidePlot[3] ) {
				res[counter] = inter[1];counter++;
			}
			if ( insidePlot[1] < inter[2][1] && inter[2][1] < insidePlot[3] &&
				minx < insidePlot[0] && maxx > insidePlot[0] ) {
				res[counter] = inter[2];counter++;
			}
			if ( insidePlot[1] < inter[3][1] && inter[3][1] < insidePlot[3] &&
				minx < insidePlot[2] && maxx > insidePlot[2] ) {
				res[counter] = inter[3];counter++;
			}
			if ( counter == 2 ) {
				gCourant.drawLine(f2i(res[0][0]),f2i(res[0][1]),f2i(res[1][0]),f2i(res[1][1]));
			}
	} 
	
// display the area selected
	protected void displayArea( float[] coord , Color color) {
		if ( coord !=null ){
			gCourant.setColor(color);
			gCourant.clearRect(insidePlot[0]-1,insidePlot[1]-1,PLOT_WIDTH+2,PLOT_HEIGHT+2);
			paintBody(gCourant);			
			plot(xplot,yplot,PLOT_COLOR);
			if ( coord[2] < 0  ) {
				coord[0] += coord[2];
				coord[2] = - coord[2];
			}
			if ( coord[3] <0 ) {
				coord[1] += coord[3];  
				coord[3] = -coord[3] ;
			}
			if (coord[0] < insidePlot[0] ){
				coord[2] -= (insidePlot[0] - coord[0]); 
				coord[0] = insidePlot[0] ;
			}	
			if ( coord[1] < insidePlot[1] ) {
				coord[3] -= ( insidePlot[1] - coord[1]);
				coord[1] = insidePlot[1];
			}
			if ( (coord[0] + coord[2]) > insidePlot[2] ) 
				coord[2] = insidePlot[2] - coord[0];
			if ( (coord[1] + coord[3]) > insidePlot[3])
				coord[3]= insidePlot[3] - coord[1];
			gCourant.drawRect(f2i(coord[0]),f2i(coord[1]),f2i(coord[2]),f2i(coord[3]));
		}
	}

// give the closest of (X,Y) and the distance must be at least under "precision" */
	protected float[] getNearPoint( float X , float Y , int precision ) {
		int start = 0 ;
		float coordx ,coordy,distance;
		float[] result = new float[3];
		int length = ((xplot.length > yplot.length )? yplot.length : xplot.length);
		int oldNorm = -1,newNorm = -1;
		float minX = minMax[0],maxX = minMax[1];
		float minY = minMax[2],maxY = minMax[3];

		float initResult = minX-10 ;
		result[0] = initResult;
		
		while ( (start < length) &&  !(isInPlotArea(xplot[start],yplot[start])))
			start ++;
		if ( start >= length ) 
			return null;	
		float[] res = new float[2];
		res = coord2pointValue(xplot[start],yplot[start]);
		coordx = res[0] ; coordy = res[1] ;		
		newNorm = normSquare(coordx-X,coordy-Y);
		if (  newNorm< precision ){ 	
			oldNorm = newNorm;
			result[0] =(new Float(xplot[start])).intValue(); 
			result[1]=(new Float(yplot[start])).intValue();
			result[2] = (new Float(indicePoint[start])).intValue();
		}
		for (int i = start + 1 ; i< length ; i++ ){
			if ( isInPlotArea(xplot[i],yplot[i])){
				res = coord2pointValue(xplot[i],yplot[i]);
				coordx = res[0] ; coordy = res[1] ;		
				newNorm= normSquare(coordx-X,coordy-Y);
				if (  newNorm < precision &&
				       ( (oldNorm<0) || (newNorm < oldNorm ) )  
				){ 	
					oldNorm = newNorm;
					result[0] = xplot[i]; 
					result[1] = yplot[i];
					result[2] = indicePoint[i];

				}
			}						
		}
		if ( result[0] == initResult ) 
			result = null;
		return result;
	}

// norme euclidienne
	private int normSquare( float x, float y ) {
		float norm = (x*x+y*y);
		return ((new Float(norm)).intValue());
	}

// convert  the coords of a point to the coords in the scale
	private float[] pointValue2coord(int x ,int y ){
		float[] coord = new float[2];
		float X =(float)x , Y= (float)y;
		coord[0] = (X-insidePlot[0]) * lengthscaleX / PLOT_WIDTH + minMax[0] ;
		coord[1] =  -(Y - insidePlot[1]) * lengthscaleY / PLOT_HEIGHT + minMax[3];
		return coord;
	}

// convert the coords of a point of the scale to the coords of the Graphic 
	private float[] coord2pointValue(float x , float y ){
		float[] coord = new float[2] ;

		coord[0] = (x - minMax[0])* PLOT_WIDTH /lengthscaleX + insidePlot[0] ;
		coord[1] = (minMax[2]-y)* PLOT_HEIGHT/ lengthscaleY + insidePlot[3] ;

		return coord;
	}

// fonction pour les erreurs specifiques a la classe
	private boolean error(String msg) {
		IJ.showMessage( name_class , msg);
		return false;
	}

// fonction liee au addMouseListener
	public void mousePressed(MouseEvent e) {
		if ( bzoom ) {
			int mouseX = e.getX();
			int mouseY = e.getY();
			float[] coord = pointValue2coord(mouseX,mouseY);
			zoom = new float[4];
			zoom[0] = coord[0];
			zoom[3] = coord[1];
		} 
	}
	
	public void mouseReleased(MouseEvent e) {
		if ( bzoom) {
			int mouseX = e.getX();
			int mouseY = e.getY();
			float[] coord = pointValue2coord(mouseX,mouseY);

			zoom[1] = coord[0];
			zoom[2] = coord[1];
				
		}
		coordArea = null;
	}

	public void mouseExited(MouseEvent e) {}
	
	public void mouseClicked(MouseEvent e) {
		int mouseX = e.getX();
		int mouseY = e.getY();
		selectedPoint  = getNearPoint((float)mouseX,(float)mouseY,DIMSQUARE_AREA_SEARCH ) ;	
	}

	public void mouseEntered(MouseEvent e) {}

// fonction liee au addMouseMotionListener
	public void mouseDragged( MouseEvent e) {
		if (bzoom) {
			coordArea = new float[4];	
			coordArea[0] = (zoom[0] - minMax[0])* PLOT_WIDTH /lengthscaleX + insidePlot[0] ;
			coordArea[1] = (minMax[2]-zoom[3])* PLOT_HEIGHT/ lengthscaleY + insidePlot[3] ;
		
			coordArea[2] = ((float) e.getX() - coordArea[0] ) ;
			coordArea[3] = ((float) e.getY() - coordArea[1] );
			repaint();
		}
	}
	
	public void mouseMoved( MouseEvent e ) {}



	private void initDim(){

		dim = super.getSize();
		WIDTH_MAX = dim.width-1 ; HEIGHT_MAX=dim.height-1;
		DIMSQUARE_AREA_SEARCH = 9;
		DIM_POINT = 2;		
		HEIGHT_STRING = HEIGHT_MAX/ 18 ; // 12
		WIDTH_STRING = WIDTH_MAX /55; // 7

	// name of the axes 
		LABEL_ABSCISSE = CTPSsec;
		LABEL_ORDONNEE = CINT;

	// dimension of the plot area
		OFFSET_BOTTOM=HEIGHT_MAX/12 ;
		OFFSET_TOP=HEIGHT_MAX/12 + HEIGHT_STRING ;
		OFFSET_RIGHT= (LABEL_ABSCISSE.length() + LABEL_ABSCISSE.length()/3 )* WIDTH_STRING  ;
		OFFSET_LEFT=WIDTH_MAX/20+ 4*WIDTH_STRING ;
		PLOT_WIDTH= WIDTH_MAX -OFFSET_RIGHT- OFFSET_LEFT ;
		PLOT_HEIGHT= HEIGHT_MAX -OFFSET_BOTTOM  - OFFSET_TOP ;
		insidePlot[0]  = OFFSET_LEFT ;
		insidePlot[1]  = OFFSET_TOP ;
		insidePlot[2]  = WIDTH_MAX-OFFSET_RIGHT;
		insidePlot[3]  = HEIGHT_MAX-OFFSET_BOTTOM;

	// for the graduation 	
		graduationX = PLOT_WIDTH/ NUMBER_SCALEX; 
		subgraduationX = graduationX/2;
		graduationY=PLOT_HEIGHT/ NUMBER_SCALEY; 
		subgraduationY = graduationY/2;
	}

}